=== modified file 'Makefile'
--- Makefile	2011-10-22 00:46:35 +0000
+++ Makefile	2011-10-11 19:36:00 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.4.1
+version=1.4.0
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -260,6 +260,12 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
+	@echo "#################################################################"
+	@echo "# NOTE: Please IGNORE the error about \"Could not open file      #"
+	@echo "# u'/var/run/mandos.pid'\" -  it is harmless and is caused by    #"
+	@echo "# the server not running as root.  Do NOT run \"make run-server\" #"
+	@echo "# server as root if you didn't also unpack and compile it thus. #"
+	@echo "#################################################################"
 	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
 
 # Used by run-server

=== modified file 'NEWS'
--- NEWS	2011-10-15 16:48:03 +0000
+++ NEWS	2011-10-09 17:36:01 +0000
@@ -1,12 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.4.1 (2011-10-15)
-* Server
-** Make D-Bus properties settable again, and handle checkers
-   for disabled clients correctly.
-* Miscellaneous fixes to "pedantic" Lintian warnings
-
 Version 1.4.0 (2011-10-09)
 * README file migrated to manual page intro(8mandos).
 * Client:

=== modified file 'TODO'
--- TODO	2011-11-09 17:16:03 +0000
+++ TODO	2011-10-09 15:21:16 +0000
@@ -41,7 +41,8 @@
 
 * mandos (server)
 ** TODO [#B] Log level							  :BUGS:
-  
+** TODO Persistent state						  :BUGS:
+   /var/lib/mandos/*
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
 ** TODO [#C] config for TXT record
@@ -52,6 +53,8 @@
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
    [[info:standards:Option%20Table][Table of Long Options]]
+** TODO Date+time on console log messages				  :BUGS:
+   Is this the default?
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on secrets given
@@ -63,8 +66,8 @@
 ** TODO [#C] python-parsedatetime
 ** TODO [#C] systemd/launchd
    http://0pointer.de/blog/projects/systemd.html
-   http://wiki.debian.org/systemd
 ** TODO Separate logging logic to own object
+** TODO make clients to a dict!
 ** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
 ** TODO [#B] break the wait on approval_delay if connection dies
 ** TODO Generate Client.runtime_expansions from client options + extra
@@ -78,7 +81,6 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 ** TODO Support RFC 3339 time duration syntax
-** TODO Send milliseconds if bare integer is passed as time duration
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with

=== modified file 'common.ent'
--- common.ent	2011-10-15 16:48:03 +0000
+++ common.ent	2011-10-09 17:36:01 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.4.1">
+<!ENTITY version "1.4.0">

=== modified file 'debian/changelog'
--- debian/changelog	2011-10-15 16:48:03 +0000
+++ debian/changelog	2011-10-09 17:36:01 +0000
@@ -1,16 +1,3 @@
-mandos (1.4.1-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/control (Build-Depends): Added "man".
-  * debian/control (Conflicts): Changed to "Breaks:".
-  * debian/copyright: Updated format.
-  * debian/mandos-client.postinst: Use "set -e" instead of "#!/bin/sh -e".
-  * debian/mandos-client.postrm: - '' -
-  * debian/mandos.postinst: - '' -
-  * debian/mandos.prerm: Consistent magic.
-
- -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 15 Oct 2011 18:18:52 +0200
-
 mandos (1.4.0-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'mandos'
--- mandos	2011-11-09 17:16:03 +0000
+++ mandos	2011-10-10 20:29:58 +0000
@@ -63,7 +63,6 @@
 import cPickle as pickle
 import multiprocessing
 import types
-import hashlib
 
 import dbus
 import dbus.service
@@ -74,7 +73,6 @@
 import ctypes.util
 import xml.dom.minidom
 import inspect
-import Crypto.Cipher.AES
 
 try:
     SO_BINDTODEVICE = socket.SO_BINDTODEVICE
@@ -85,11 +83,10 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.4.1"
-
-logger = logging.getLogger()
-stored_state_path = "/var/lib/mandos/clients.pickle"
-
+version = "1.4.0"
+
+#logger = logging.getLogger('mandos')
+logger = logging.Logger('mandos')
 syslogger = (logging.handlers.SysLogHandler
              (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
               address = str("/dev/log")))
@@ -99,13 +96,11 @@
 logger.addHandler(syslogger)
 
 console = logging.StreamHandler()
-console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
-                                       ' [%(process)d]:'
+console.setFormatter(logging.Formatter('%(name)s [%(process)d]:'
                                        ' %(levelname)s:'
                                        ' %(message)s'))
 logger.addHandler(console)
 
-
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
         self.value = value
@@ -169,6 +164,10 @@
                             .GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
+        syslogger.setFormatter(logging.Formatter
+                               ('Mandos (%s) [%%(process)d]:'
+                                ' %%(levelname)s: %%(message)s'
+                                % self.name))
         self.remove()
         try:
             self.add()
@@ -194,7 +193,7 @@
                 avahi.DBUS_INTERFACE_ENTRY_GROUP)
         self.entry_group_state_changed_match = (
             self.group.connect_to_signal(
-                'StateChanged', self.entry_group_state_changed))
+                'StateChanged', self .entry_group_state_changed))
         logger.debug("Adding Zeroconf service '%s' of type '%s' ...",
                      self.name, self.type)
         self.group.AddService(
@@ -266,15 +265,6 @@
                                  self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
-class AvahiServiceToSyslog(AvahiService):
-    def rename(self):
-        """Add the new name to the syslog messages"""
-        ret = AvahiService.rename(self)
-        syslogger.setFormatter(logging.Formatter
-                               ('Mandos (%s) [%%(process)d]:'
-                                ' %%(levelname)s: %%(message)s'
-                                % self.name))
-        return ret
 
 def _timedelta_to_milliseconds(td):
     "Convert a datetime.timedelta() to milliseconds"
@@ -299,9 +289,8 @@
                      instance %(name)s can be used in the command.
     checker_initiator_tag: a gobject event source tag, or None
     created:    datetime.datetime(); (UTC) object creation
-    client_structure: Object describing what attributes a client has
-                      and is used for storing the client at exit
     current_checker_command: string; current running checker_command
+    disable_hook:  If set, called by disable() as disable_hook(self)
     disable_initiator_tag: a gobject event source tag, or None
     enabled:    bool()
     fingerprint: string (40 or 32 hexadecimal digits); used to
@@ -310,9 +299,6 @@
     interval:   datetime.timedelta(); How often to start a new checker
     last_approval_request: datetime.datetime(); (UTC) or None
     last_checked_ok: datetime.datetime(); (UTC) or None
-    last_checker_status: integer between 0 and 255 reflecting exit status
-                         of last checker. -1 reflect crashed checker,
-                         or None.
     last_enabled: datetime.datetime(); (UTC)
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
@@ -345,7 +331,7 @@
     def approval_delay_milliseconds(self):
         return _timedelta_to_milliseconds(self.approval_delay)
     
-    def __init__(self, name = None, config=None):
+    def __init__(self, name = None, disable_hook=None, config=None):
         """Note: the 'checker' key in 'config' sets the
         'checker_command' attribute and *not* the 'checker'
         attribute."""
@@ -371,22 +357,23 @@
                             % self.name)
         self.host = config.get("host", "")
         self.created = datetime.datetime.utcnow()
-        self.enabled = True
+        self.enabled = False
         self.last_approval_request = None
-        self.last_enabled = datetime.datetime.utcnow()
+        self.last_enabled = None
         self.last_checked_ok = None
-        self.last_checker_status = None
         self.timeout = string_to_delta(config["timeout"])
         self.extended_timeout = string_to_delta(config
                                                 ["extended_timeout"])
         self.interval = string_to_delta(config["interval"])
+        self.disable_hook = disable_hook
         self.checker = None
         self.checker_initiator_tag = None
         self.disable_initiator_tag = None
-        self.expires = datetime.datetime.utcnow() + self.timeout
+        self.expires = None
         self.checker_callback_tag = None
         self.checker_command = config["checker"]
         self.current_checker_command = None
+        self.last_connect = None
         self._approved = None
         self.approved_by_default = config.get("approved_by_default",
                                               True)
@@ -398,19 +385,11 @@
         self.changedstate = (multiprocessing_manager
                              .Condition(multiprocessing_manager
                                         .Lock()))
-        self.client_structure = [attr for attr in self.__dict__.iterkeys() if not attr.startswith("_")]
-        self.client_structure.append("client_structure")
-
-
-        for name, t in inspect.getmembers(type(self),
-                                          lambda obj: isinstance(obj, property)):
-            if not name.startswith("_"):
-                self.client_structure.append(name)
     
-    # Send notice to process children that client state has changed
     def send_changedstate(self):
-        with self.changedstate:
-            self.changedstate.notify_all()
+        self.changedstate.acquire()
+        self.changedstate.notify_all()
+        self.changedstate.release()
     
     def enable(self):
         """Start this client's checker and timeout hooks"""
@@ -418,10 +397,20 @@
             # Already enabled
             return
         self.send_changedstate()
+        # Schedule a new checker to be started an 'interval' from now,
+        # and every interval from then on.
+        self.checker_initiator_tag = (gobject.timeout_add
+                                      (self.interval_milliseconds(),
+                                       self.start_checker))
+        # Schedule a disable() when 'timeout' has passed
         self.expires = datetime.datetime.utcnow() + self.timeout
+        self.disable_initiator_tag = (gobject.timeout_add
+                                   (self.timeout_milliseconds(),
+                                    self.disable))
         self.enabled = True
         self.last_enabled = datetime.datetime.utcnow()
-        self.init_checker()
+        # Also start a new checker *right now*.
+        self.start_checker()
     
     def disable(self, quiet=True):
         """Disable this client."""
@@ -439,34 +428,23 @@
             gobject.source_remove(self.checker_initiator_tag)
             self.checker_initiator_tag = None
         self.stop_checker()
+        if self.disable_hook:
+            self.disable_hook(self)
         self.enabled = False
         # Do not run this again if called by a gobject.timeout_add
         return False
     
     def __del__(self):
+        self.disable_hook = None
         self.disable()
-
-    def init_checker(self):
-        # Schedule a new checker to be started an 'interval' from now,
-        # and every interval from then on.
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (self.interval_milliseconds(),
-                                       self.start_checker))
-        # Schedule a disable() when 'timeout' has passed
-        self.disable_initiator_tag = (gobject.timeout_add
-                                   (self.timeout_milliseconds(),
-                                    self.disable))
-        # Also start a new checker *right now*.
-        self.start_checker()
-
-        
+    
     def checker_callback(self, pid, condition, command):
         """The checker has completed, so take appropriate actions."""
         self.checker_callback_tag = None
         self.checker = None
         if os.WIFEXITED(condition):
-            self.last_checker_status =  os.WEXITSTATUS(condition)
-            if self.last_checker_status == 0:
+            exitstatus = os.WEXITSTATUS(condition)
+            if exitstatus == 0:
                 logger.info("Checker for %(name)s succeeded",
                             vars(self))
                 self.checked_ok()
@@ -474,7 +452,6 @@
                 logger.info("Checker for %(name)s failed",
                             vars(self))
         else:
-            self.last_checker_status = -1
             logger.warning("Checker for %(name)s crashed?",
                            vars(self))
     
@@ -487,13 +464,11 @@
         if timeout is None:
             timeout = self.timeout
         self.last_checked_ok = datetime.datetime.utcnow()
-        if self.disable_initiator_tag is not None:
-            gobject.source_remove(self.disable_initiator_tag)
-        if getattr(self, "enabled", False):
-            self.disable_initiator_tag = (gobject.timeout_add
-                                          (_timedelta_to_milliseconds
-                                           (timeout), self.disable))
-            self.expires = datetime.datetime.utcnow() + timeout
+        gobject.source_remove(self.disable_initiator_tag)
+        self.disable_initiator_tag = (gobject.timeout_add
+                                      (_timedelta_to_milliseconds
+                                       (timeout), self.disable))
+        self.expires = datetime.datetime.utcnow() + timeout
     
     def need_approval(self):
         self.last_approval_request = datetime.datetime.utcnow()
@@ -591,52 +566,6 @@
                 raise
         self.checker = None
 
-    # Encrypts a client secret and stores it in a varible encrypted_secret
-    def encrypt_secret(self, key):
-        # Encryption-key need to be of a specific size, so we hash inputed key
-        hasheng = hashlib.sha256()
-        hasheng.update(key)
-        encryptionkey = hasheng.digest()
-
-        # Create validation hash so we know at decryption if it was sucessful
-        hasheng = hashlib.sha256()
-        hasheng.update(self.secret)
-        validationhash = hasheng.digest()
-
-        # Encrypt secret
-        iv = os.urandom(Crypto.Cipher.AES.block_size)
-        ciphereng = Crypto.Cipher.AES.new(encryptionkey,
-                                        Crypto.Cipher.AES.MODE_CFB, iv)
-        ciphertext = ciphereng.encrypt(validationhash+self.secret)
-        self.encrypted_secret = (ciphertext, iv)
-
-    # Decrypt a encrypted client secret
-    def decrypt_secret(self, key):
-        # Decryption-key need to be of a specific size, so we hash inputed key
-        hasheng = hashlib.sha256()
-        hasheng.update(key)
-        encryptionkey = hasheng.digest()
-
-        # Decrypt encrypted secret
-        ciphertext, iv = self.encrypted_secret
-        ciphereng = Crypto.Cipher.AES.new(encryptionkey,
-                                        Crypto.Cipher.AES.MODE_CFB, iv)
-        plain = ciphereng.decrypt(ciphertext)
-
-        # Validate decrypted secret to know if it was succesful
-        hasheng = hashlib.sha256()
-        validationhash = plain[:hasheng.digest_size]
-        secret = plain[hasheng.digest_size:]
-        hasheng.update(secret)
-
-        # if validation fails, we use key as new secret. Otherwhise, we use
-        # the decrypted secret
-        if hasheng.digest() == validationhash:
-            self.secret = secret
-        else:
-            self.secret = key
-        del self.encrypted_secret
-
 
 def dbus_service_property(dbus_interface, signature="v",
                           access="readwrite", byte_arrays=False):
@@ -943,10 +872,9 @@
     # dbus.service.Object doesn't use super(), so we can't either.
     
     def __init__(self, bus = None, *args, **kwargs):
+        self._approvals_pending = 0
         self.bus = bus
         Client.__init__(self, *args, **kwargs)
-
-        self._approvals_pending = 0
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
         client_object_name = unicode(self.name).translate(
@@ -963,8 +891,8 @@
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
 
-        transform_fun: Function that takes a value and a variant_level
-                       and transforms it to a D-Bus type.
+        transform_fun: Function that takes a value and transforms it
+                       to a D-Bus type.
         dbus_name: D-Bus name of the variable
         type_func: Function that transform the value before sending it
                    to the D-Bus.  Default: no transform
@@ -977,8 +905,7 @@
                     type_func(getattr(self, attrname, None))
                     != type_func(value)):
                     dbus_value = transform_func(type_func(value),
-                                                variant_level
-                                                =variant_level)
+                                                variant_level)
                     self.PropertyChanged(dbus.String(dbus_name),
                                          dbus_value)
             setattr(self, attrname, value)
@@ -1260,11 +1187,12 @@
         gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = None
         self.expires = None
-        time_to_die = _timedelta_to_milliseconds((self
-                                                  .last_checked_ok
-                                                  + self.timeout)
-                                                 - datetime.datetime
-                                                 .utcnow())
+        time_to_die = (self.
+                       _timedelta_to_milliseconds((self
+                                                   .last_checked_ok
+                                                   + self.timeout)
+                                                  - datetime.datetime
+                                                  .utcnow()))
         if time_to_die <= 0:
             # The timeout has passed
             self.disable()
@@ -1694,7 +1622,7 @@
         self.enabled = False
         self.clients = clients
         if self.clients is None:
-            self.clients = {}
+            self.clients = set()
         self.use_dbus = use_dbus
         self.gnutls_priority = gnutls_priority
         IPv6_TCPServer.__init__(self, server_address,
@@ -1747,7 +1675,7 @@
             fpr = request[1]
             address = request[2]
             
-            for c in self.clients.itervalues():
+            for c in self.clients:
                 if c.fingerprint == fpr:
                     client = c
                     break
@@ -1921,10 +1849,6 @@
                         " system bus interface")
     parser.add_argument("--no-ipv6", action="store_false",
                         dest="use_ipv6", help="Do not use IPv6")
-    parser.add_argument("--no-restore", action="store_false",
-                        dest="restore", help="Do not restore stored state",
-                        default=True)
-
     options = parser.parse_args()
     
     if options.check:
@@ -1965,7 +1889,7 @@
     # options, if set.
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
-                   "use_dbus", "use_ipv6", "debuglevel", "restore"):
+                   "use_dbus", "use_ipv6", "debuglevel"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2044,13 +1968,14 @@
             raise error
     
     if not debug and not debuglevel:
-        logger.setLevel(logging.WARNING)
+        syslogger.setLevel(logging.WARNING)
+        console.setLevel(logging.WARNING)
     if debuglevel:
         level = getattr(logging, debuglevel.upper())
-        logger.setLevel(level)
+        syslogger.setLevel(level)
+        console.setLevel(level)
     
     if debug:
-        logger.setLevel(logging.DEBUG)
         # Enable all possible GnuTLS debugging
         
         # "Use a log level over 10 to enable all debugging options."
@@ -2097,10 +2022,9 @@
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
     protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-    service = AvahiServiceToSyslog(name =
-                                   server_settings["servicename"],
-                                   servicetype = "_mandos._tcp",
-                                   protocol = protocol, bus = bus)
+    service = AvahiService(name = server_settings["servicename"],
+                           servicetype = "_mandos._tcp",
+                           protocol = protocol, bus = bus)
     if server_settings["interface"]:
         service.interface = (if_nametoindex
                              (str(server_settings["interface"])))
@@ -2112,102 +2036,23 @@
     if use_dbus:
         client_class = functools.partial(ClientDBusTransitional,
                                          bus = bus)
-    
-    special_settings = {
-        # Some settings need to be accessd by special methods;
-        # booleans need .getboolean(), etc.  Here is a list of them:
-        "approved_by_default":
-            lambda section:
-            client_config.getboolean(section, "approved_by_default"),
-        }
-    # Construct a new dict of client settings of this form:
-    # { client_name: {setting_name: value, ...}, ...}
-    # with exceptions for any special settings as defined above
-    client_settings = dict((clientname,
-                           dict((setting,
-                                 (value if setting not in special_settings
-                                  else special_settings[setting](clientname)))
-                                for setting, value in client_config.items(clientname)))
-                          for clientname in client_config.sections())
-    
-    old_client_settings = {}
-    clients_data = []
-
-    # Get client data and settings from last running state. 
-    if server_settings["restore"]:
-        try:
-            with open(stored_state_path, "rb") as stored_state:
-                clients_data, old_client_settings = pickle.load(stored_state)
-            os.remove(stored_state_path)
-        except IOError as e:
-            logger.warning("Could not load persistant state: {0}".format(e))
-            if e.errno != errno.ENOENT:
-                raise
-
-    for client in clients_data:
-        client_name = client["name"]
-        
-        # Decide which value to use after restoring saved state.
-        # We have three different values: Old config file,
-        # new config file, and saved state.
-        # New config value takes precedence if it differs from old
-        # config value, otherwise use saved state.
-        for name, value in client_settings[client_name].items():
+    def client_config_items(config, section):
+        special_settings = {
+            "approved_by_default":
+                lambda: config.getboolean(section,
+                                          "approved_by_default"),
+            }
+        for name, value in config.items(section):
             try:
-                # For each value in new config, check if it differs
-                # from the old config value (Except for the "secret"
-                # attribute)
-                if name != "secret" and value != old_client_settings[client_name][name]:
-                    setattr(client, name, value)
+                yield (name, special_settings[name]())
             except KeyError:
-                pass
-
-        # Clients who has passed its expire date, can still be enabled if its
-        # last checker was sucessful. Clients who checkers failed before we
-        # stored it state is asumed to had failed checker during downtime.
-        if client["enabled"] and client["last_checked_ok"]:
-            if ((datetime.datetime.utcnow() - client["last_checked_ok"])
-                > client["interval"]):
-                if client["last_checker_status"] != 0:
-                    client["enabled"] = False
-                else:
-                    client["expires"] = datetime.datetime.utcnow() + client["timeout"]
-
-        client["changedstate"] = (multiprocessing_manager
-                                  .Condition(multiprocessing_manager
-                                             .Lock()))
-        if use_dbus:
-            new_client = ClientDBusTransitional.__new__(ClientDBusTransitional)
-            tcp_server.clients[client_name] = new_client
-            new_client.bus = bus
-            for name, value in client.iteritems():
-                setattr(new_client, name, value)
-            client_object_name = unicode(client_name).translate(
-                {ord("."): ord("_"),
-                 ord("-"): ord("_")})
-            new_client.dbus_object_path = (dbus.ObjectPath
-                                     ("/clients/" + client_object_name))
-            DBusObjectWithProperties.__init__(new_client,
-                                              new_client.bus,
-                                              new_client.dbus_object_path)
-        else:
-            tcp_server.clients[client_name] = Client.__new__(Client)
-            for name, value in client.iteritems():
-                setattr(tcp_server.clients[client_name], name, value)
-                
-        tcp_server.clients[client_name].decrypt_secret(
-            client_settings[client_name]["secret"])            
-        
-    # Create/remove clients based on new changes made to config
-    for clientname in set(old_client_settings) - set(client_settings):
-        del tcp_server.clients[clientname]
-    for clientname in set(client_settings) - set(old_client_settings):
-        tcp_server.clients[clientname] = (client_class(name = clientname,
-                                                       config =
-                                                       client_settings
-                                                       [clientname]))
+                yield (name, value)
     
-
+    tcp_server.clients.update(set(
+            client_class(name = section,
+                         config= dict(client_config_items(
+                        client_config, section)))
+            for section in client_config.sections()))
     if not tcp_server.clients:
         logger.warning("No clients defined")
         
@@ -2256,8 +2101,7 @@
             def GetAllClients(self):
                 "D-Bus method"
                 return dbus.Array(c.dbus_object_path
-                                  for c in
-                                  tcp_server.clients.itervalues())
+                                  for c in tcp_server.clients)
             
             @dbus.service.method(_interface,
                                  out_signature="a{oa{sv}}")
@@ -2265,15 +2109,15 @@
                 "D-Bus method"
                 return dbus.Dictionary(
                     ((c.dbus_object_path, c.GetAll(""))
-                     for c in tcp_server.clients.itervalues()),
+                     for c in tcp_server.clients),
                     signature="oa{sv}")
             
             @dbus.service.method(_interface, in_signature="o")
             def RemoveClient(self, object_path):
                 "D-Bus method"
-                for c in tcp_server.clients.itervalues():
+                for c in tcp_server.clients:
                     if c.dbus_object_path == object_path:
-                        del tcp_server.clients[c.name]
+                        tcp_server.clients.remove(c)
                         c.remove_from_connection()
                         # Don't signal anything except ClientRemoved
                         c.disable(quiet=True)
@@ -2293,44 +2137,11 @@
         service.cleanup()
         
         multiprocessing.active_children()
-        if not (tcp_server.clients or client_settings):
-            return
-
-        # Store client before exiting. Secrets are encrypted with key based
-        # on what config file has. If config file is removed/edited, old
-        # secret will thus be unrecovable.
-        clients = []
-        for client in tcp_server.clients.itervalues():
-            client.encrypt_secret(client_settings[client.name]["secret"])
-
-            client_dict = {}
-
-            # A list of attributes that will not be stored when shuting down.
-            exclude = set(("bus", "changedstate", "secret"))            
-            for name, typ in inspect.getmembers(dbus.service.Object):
-                exclude.add(name)
-                
-            client_dict["encrypted_secret"] = client.encrypted_secret
-            for attr in client.client_structure:
-                if attr not in exclude:
-                    client_dict[attr] = getattr(client, attr)
-
-            clients.append(client_dict) 
-            del client_settings[client.name]["secret"]
-            
-        try:
-            with os.fdopen(os.open(stored_state_path, os.O_CREAT|os.O_WRONLY|os.O_TRUNC, 0600), "wb") as stored_state:
-                pickle.dump((clients, client_settings), stored_state)
-        except IOError as e:
-            logger.warning("Could not save persistant state: {0}".format(e))
-            if e.errno != errno.ENOENT:
-                raise
-
-        # Delete all clients, and settings from config
         while tcp_server.clients:
-            name, client = tcp_server.clients.popitem()
+            client = tcp_server.clients.pop()
             if use_dbus:
                 client.remove_from_connection()
+            client.disable_hook = None
             # Don't signal anything except ClientRemoved
             client.disable(quiet=True)
             if use_dbus:
@@ -2338,18 +2149,14 @@
                 mandos_dbus_service.ClientRemoved(client
                                                   .dbus_object_path,
                                                   client.name)
-        client_settings.clear()
     
     atexit.register(cleanup)
     
-    for client in tcp_server.clients.itervalues():
+    for client in tcp_server.clients:
         if use_dbus:
             # Emit D-Bus signal
             mandos_dbus_service.ClientAdded(client.dbus_object_path)
-        # Need to initiate checking of clients
-        if client.enabled:
-            client.init_checker()
-
+        client.enable()
     
     tcp_server.enable()
     tcp_server.server_activate()

=== modified file 'mandos-ctl'
--- mandos-ctl	2011-10-15 16:48:03 +0000
+++ mandos-ctl	2011-10-09 17:36:01 +0000
@@ -60,7 +60,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.4.1"
+version = "1.4.0"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""
@@ -301,41 +301,41 @@
                                          dbus_interface=
                                          dbus.PROPERTIES_IFACE)
                          else 1)
-            if options.checker is not None:
+            if options.checker:
                 client.Set(client_interface, "Checker",
                            options.checker,
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.host is not None:
+            if options.host:
                 client.Set(client_interface, "Host", options.host,
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.interval is not None:
+            if options.interval:
                 client.Set(client_interface, "Interval",
                            timedelta_to_milliseconds
                            (string_to_delta(options.interval)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.approval_delay is not None:
+            if options.approval_delay:
                 client.Set(client_interface, "ApprovalDelay",
                            timedelta_to_milliseconds
                            (string_to_delta(options.
                                             approval_delay)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.approval_duration is not None:
+            if options.approval_duration:
                 client.Set(client_interface, "ApprovalDuration",
                            timedelta_to_milliseconds
                            (string_to_delta(options.
                                             approval_duration)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.timeout is not None:
+            if options.timeout:
                 client.Set(client_interface, "Timeout",
                            timedelta_to_milliseconds
                            (string_to_delta(options.timeout)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.extended_timeout is not None:
+            if options.extended_timeout:
                 client.Set(client_interface, "ExtendedTimeout",
                            timedelta_to_milliseconds
                            (string_to_delta(options.extended_timeout)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.secret is not None:
+            if options.secret:
                 client.Set(client_interface, "Secret",
                            dbus.ByteArray(open(options.secret,
                                                "rb").read()),

=== modified file 'mandos-keygen'
--- mandos-keygen	2011-10-15 16:48:03 +0000
+++ mandos-keygen	2011-10-09 17:36:01 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.4.1"
+VERSION="1.4.0"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2011-10-15 16:48:03 +0000
+++ mandos-monitor	2011-10-09 17:36:01 +0000
@@ -52,7 +52,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.4.1"
+version = "1.4.0"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2011-11-09 17:16:03 +0000
+++ mandos-options.xml	2009-02-13 05:38:21 +0000
@@ -85,10 +85,5 @@
     to the server if this option is turned off.  <emphasis>Only
     advanced users should consider changing this option</emphasis>.
   </para>
-
-  <para id="restore">
-    This option controls whether the server will restore any state from
-    last time it ran. Default is to try restore last state.
-  </para>
   
 </section>

=== modified file 'mandos.lsm'
--- mandos.lsm	2011-10-15 16:48:03 +0000
+++ mandos.lsm	2011-10-09 17:36:01 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.4.1
-Entered-date:	2011-10-15
+Version:	1.4.0
+Entered-date:	2011-10-09
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site: http://www.recompile.se/mandos
-	      138K mandos_1.4.1.orig.tar.gz
+	      137K mandos_1.4.0.orig.tar.gz
 Alternate-site: ftp://ftp.recompile.se/pub/mandos
-		138K mandos_1.4.1.orig.tar.gz
+		137K mandos_1.4.0.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2011-11-09 17:16:03 +0000
+++ mandos.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2011-10-22">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -94,8 +94,6 @@
       <arg><option>--no-dbus</option></arg>
       <sbr/>
       <arg><option>--no-ipv6</option></arg>
-      <sbr/>
-      <arg><option>--no-restore</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -277,13 +275,6 @@
 	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
 	</listitem>
       </varlistentry>
-      
-      <varlistentry>
-	<term><option>--no-restore</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="restore"/>
-	</listitem>
-      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -518,6 +509,9 @@
       Debug mode is conflated with running in the foreground.
     </para>
     <para>
+      The console log messages do not show a time stamp.
+    </para>
+    <para>
       This server does not check the expire time of clients’ OpenPGP
       keys.
     </para>

